/*******************************************************************************
Copyright (C) Marvell International Ltd. and its affiliates

This software file (the "File") is owned and distributed by Marvell 
International Ltd. and/or its affiliates ("Marvell") under the following
alternative licensing terms.  Once you have made an election to distribute the
File under one of the following license alternatives, please (i) delete this
introductory statement regarding license alternatives, (ii) delete the two
license alternatives that you have not elected to use and (iii) preserve the
Marvell copyright notice above.

********************************************************************************
Marvell Commercial License Option

If you received this File from Marvell and you have entered into a commercial
license agreement (a "Commercial License") with Marvell, the File is licensed
to you under the terms of the applicable Commercial License.

********************************************************************************
Marvell GPL License Option

If you received this File from Marvell, you may opt to use, redistribute and/or 
modify this File in accordance with the terms and conditions of the General 
Public License Version 2, June 1991 (the "GPL License"), a copy of which is 
available along with the File in the license.txt file or by writing to the Free 
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 or 
on the worldwide web at http://www.gnu.org/licenses/gpl.txt. 

THE FILE IS DISTRIBUTED AS-IS, WITHOUT WARRANTY OF ANY KIND, AND THE IMPLIED 
WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY 
DISCLAIMED.  The GPL License provides additional details about this warranty 
disclaimer.
********************************************************************************
Marvell BSD License Option

If you received this File from Marvell, you may opt to use, redistribute and/or 
modify this File under the following licensing terms. 
Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

    *   Redistributions of source code must retain the above copyright notice,
	    this list of conditions and the following disclaimer. 

    *   Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution. 

    *   Neither the name of Marvell nor the names of its contributors may be 
        used to endorse or promote products derived from this software without 
        specific prior written permission. 
    
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR 
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*******************************************************************************/


#ifndef __INCmvDS1339Regh
#define __INCmvDS1339Regh

#ifndef MSK
#define MSK(n)						((1 << (n)) - 1)
#endif

#define RTC_CLOCK_SECONDS			0x00
#define RTC_CLOCK_MINUTES			0x01
#define RTC_CLOCK_HOUR				0x02
#define RTC_CLOCK_DATE				0x03
#define RTC_CLOCK_MONTH 	 		0x04
#define RTC_CLOCK_YEAR				0x05
#define RTC_CLOCK_DAY				0x06
#define RTC_STATUS				0x07
#define RTC_CONTROL				0x08
#define RTC_RESERVED				0x09
#define RTC_ANALOG_TRIM				0x0A
#define RTC_DIGITAL_TRIM			0x0B
#define RTC_ALARM_SECONDS			0x0C
#define RTC_ALARM_MINUTES			0x0D
#define RTC_ALARM_HOUR				0x0E
#define RTC_ALARM_DATE				0x0F
#define RTC_ALARM_MONTH				0x10
#define RTC_ALARM_DAY 				0x11

#define FIRST_REG_OFF				RTC_CLOCK_SECONDS
#define LAST_REG_OFF				RTC_ALARM_DAY


/* RTC_CLOCK_SECONDS   0x0*/

#define RTC_CLOCK_SECONDS_SHF		0
#define RTC_CLOCK_SECONDS_MSK		(MSK(4)<<RTC_CLOCK_SECONDS_SHF)

#define RTC_CLOCK_10SECONDS_SHF		4
#define RTC_CLOCK_10SECONDS_MSK		(MSK(3)<<RTC_CLOCK_10SECONDS_SHF)


/* RTC_CLOCK_MINUTES   0x1*/

#define RTC_CLOCK_MINUTES_SHF		0
#define RTC_CLOCK_MINUTES_MSK		(MSK(4)<<RTC_CLOCK_MINUTES_SHF)

#define RTC_CLOCK_10MINUTES_SHF		4
#define RTC_CLOCK_10MINUTES_MSK		(MSK(3)<<RTC_CLOCK_10MINUTES_SHF)


/* RTC_CLOCK_HOUR      0x2*/

#define RTC_CLOCK_HOURS_SHF		0
#define RTC_CLOCK_HOURS_MSK		(MSK(4)<<RTC_CLOCK_HOURS_SHF)

#define RTC_CLOCK_10HOURS_SHF		4
#define RTC_CLOCK_10HOURS_MSK1		(MSK(1)<<RTC_CLOCK_10HOURS_SHF)
#define RTC_CLOCK_10HOURS_MSK2		(MSK(2)<<RTC_CLOCK_10HOURS_SHF)
#define RTC_CLOCK_10HOURS_BIT		BIT4

#define RTC_CLOCK_10HOURSAMPM_SHF	5
#define RTC_CLOCK_10HOURSAMPM_MSK	(MSK(1)<<RTC_CLOCK_10HOURSAMPM_SHF)
#define RTC_CLOCK_10HOURSAMPM_BIT	BIT5

#define RTC_CLOCK_HOUR_12_24		7
#define RTC_CLOCK_HOUR_12_24_MSK	(MSK(1)<<RTC_CLOCK_HOUR_12_24_SHF)
#define RTC_CLOCK_HOUR_12_24_BIT	BIT7


/* RTC_CLOCK_DATE      	0x3*/

#define RTC_CLOCK_DATE_SHF		0
#define RTC_CLOCK_DATE_MSK		(MSK(4)<<RTC_CLOCK_DATE_SHF)

#define RTC_CLOCK_10DATE_SHF		4
#define RTC_CLOCK_10DATE_MSK		(MSK(2)<<RTC_CLOCK_10DATE_SHF)


/* RTC_CLOCK_MONTH    	0x4*/

#define RTC_CLOCK_MONTH_SHF		0
#define RTC_CLOCK_MONTH_MSK		(MSK(4)<<RTC_CLOCK_MONTH_SHF)

#define RTC_CLOCK_10MONTH_SHF		4
#define RTC_CLOCK_10MONTH_MSK		(MSK(1)<<RTC_CLOCK_10MONTH_SHF)
#define RTC_CLOCK_10MONTH_BIT		BIT4


/* RTC_CLOCK_YEAR      	0x5*/

#define RTC_CLOCK_YEAR_SHF		0
#define RTC_CLOCK_YEAR_MSK		(MSK(4)<<RTC_CLOCK_YEAR_SHF)

#define RTC_CLOCK_10YEAR_SHF		4
#define RTC_CLOCK_10YEAR_MSK		(MSK(4)<<RTC_CLOCK_10YEAR_SHF)


/* RTC_CLOCK_DAY       	0x6*/

#define RTC_CLOCK_DAY_SHF		0
#define RTC_CLOCK_DAY_MSK		(MSK(3)<<RTC_CLOCK_DAY_SHF)


/* RTC_ALARM_SECONDS  	0xC*/

#define RTC_CLOCK_SECONDS_ALRM1_SHF	0
#define RTC_CLOCK_SECONDS_ALRM1_MSK	(MSK(4)<<RTC_CLOCK_SECONDS_ALRM1_SHF)

#define RTC_CLOCK_10SECONDS_ALRM1_SHF	4
#define RTC_CLOCK_10SECONDS_ALRM1_MSK	(MSK(3)<<RTC_CLOCK_10SECONDS_ALRM1_SHF)

#define RTC_CLOCK_A1M1_SHF		0
#define RTC_CLOCK_A1M1_MSK		(MSK(1)<<RTC_CLOCK_A1M1_SHF)
#define RTC_CLOCK_A1M1_BIT		BIT7


/* RTC_ALARM_MINUTES   	0xD*/

#define RTC_CLOCK_MINUTES_ALRM1_SHF	0
#define RTC_CLOCK_MINUTES_ALRM1_MSK	(MSK(4)<<RTC_CLOCK_MINUTES_ALRM1_SHF)

#define RTC_CLOCK_10MINUTES_ALRM1_SHF	4
#define RTC_CLOCK_10MINUTES_ALRM1_MSK	(MSK(3)<<RTC_CLOCK_10MINUTES_ALRM1_SHF)

#define RTC_CLOCK_A1M2_SHF		0
#define RTC_CLOCK_A1M2_MSK		(MSK(1)<<RTC_CLOCK_A1M2_SHF)
#define RTC_CLOCK_A1M2_BIT		BIT7


/* RTC_ALARM_HOUR      	0xE*/

#define RTC_CLOCK_HOURS_ALRM1_SHF	0
#define RTC_CLOCK_HOURS_ALRM1_MSK	(MSK(4)<<RTC_CLOCK_HOURS_ALRM1_SHF)

#define RTC_CLOCK_10HOURS_ALRM1_SHF	4
#define RTC_CLOCK_10HOURS_ALRM1_MSK1	(MSK(1)<<RTC_CLOCK_10HOURS_ALRM1_SHF)
#define RTC_CLOCK_10HOURS_ALRM1_MSK2	(MSK(2)<<RTC_CLOCK_10HOURS_ALRM1_SHF)
#define RTC_CLOCK_10HOURS_ALRM1_BIT	BIT4

#define RTC_CLOCK_10HOURS_ALRM1AMPM_SHF	5
#define RTC_CLOCK_10HOURS_ALRM1AMPM_MSK	(MSK(1)<<RTC_CLOCK_10HOURS_ALRM1AMPM_SHF)
#define RTC_CLOCK_10HOURS_ALRM1AMPM_BIT	BIT5

#define RTC_CLOCK_A1M3_SHF		0
#define RTC_CLOCK_A1M3_MSK		(MSK(1)<<RTC_CLOCK_A1M3_SHF)
#define RTC_CLOCK_A1M3_BIT		BIT7


/* RTC_ALARM_DATE  	0xF*/

#define RTC_CLOCK_DATE_ALRM1_SHF	0
#define RTC_CLOCK_DATE_ALRM1_MSK	(MSK(4)<<RTC_CLOCK_DATE_ALRM1_SHF)

#define RTC_CLOCK_10DATE_ALRM1_SHF	4
#define RTC_CLOCK_10DATE_ALRM1_MSK	(MSK(2)<<RTC_CLOCK_10DATE_ALRM1_SHF)

#define RTC_CLOCK_A1M4_SHF		0
#define RTC_CLOCK_A1M4_MSK		(MSK(1)<<RTC_CLOCK_A1M4_SHF)
#define RTC_CLOCK_A1M4_BIT		BIT7


/* RTC_ALARM_MONTH  	0x10*/

#define RTC_CLOCK_MONTH_ALRM1_SHF	0
#define RTC_CLOCK_MONTH_ALRM1_MSK	(MSK(4)<<RTC_CLOCK_MONTH_ALRM1_SHF)

#define RTC_CLOCK_10MONTH_ALRM1_SHF	4
#define RTC_CLOCK_10MONTH_ALRM1_MSK	(MSK(1)<<RTC_CLOCK_10MONTH_ALRM1_SHF)

#define RTC_CLOCK_A1M5_SHF		0
#define RTC_CLOCK_A1M5_MSK		(MSK(1)<<RTC_CLOCK_A1M5_SHF)
#define RTC_CLOCK_A1M5_BIT		BIT7


/* RTC_ALARM_DAY  	0x11*/

#define RTC_CLOCK_DAY_ALRM1_SHF		0
#define RTC_CLOCK_DAY_ALRM1_MSK		(MSK(3)<<RTC_CLOCK_DAY_ALRM1_SHF)

#define RTC_CLOCK_A1M6_SHF		0
#define RTC_CLOCK_A1M6_MSK		(MSK(1)<<RTC_CLOCK_A1M6_SHF)
#define RTC_CLOCK_A1M6_BIT		BIT7


/* RTC_STATUS  		0x7*/

#define RTC_STATUS_RTCF_SHF		0
#define RTC_STATUS_RTCF_MSK		(MSK(1)<<RTC_STATUS_RTCF_SHF)
#define RTC_STATUS_RTCF_BIT		BIT0

#define RTC_STATUS_BAT_SHF		1
#define RTC_STATUS_BAT_MSK		(MSK(1)<<RTC_STATUS_BAT_SHF)
#define RTC_STATUS_BAT_BIT		BIT1

#define RTC_STATUS_ALM_SHF		2
#define RTC_STATUS_ALM_MSK		(MSK(1)<<RTC_STATUS_ALM_SHF)
#define RTC_STATUS_ALM_BIT		BIT2

#define RTC_STATUS_WRTC_SHF		4
#define RTC_STATUS_WRTC_MSK		(MSK(1)<<RTC_STATUS_WRTC_SHF)
#define RTC_STATUS_WRTC_BIT		BIT4

#define RTC_STATUS_XTOSCB_SHF		6
#define RTC_STATUS_XTOSCB_MSK		(MSK(1)<<RTC_STATUS_XTOSCB_SHF)
#define RTC_STATUS_XTOSCB_BIT		BIT6

#define RTC_STATUS_ARST_SHF		7
#define RTC_STATUS_ARST_MSK		(MSK(1)<<RTC_STATUS_ARST_SHF)
#define RTC_STATUS_ARST_BIT		BIT7


/* RTC_CONTROL  	0x8*/

#define RTC_CONTROL_FOUT_SHF		0
#define RTC_CONTROL_FOUT_MSK		(MSK(4)<<RTC_CONTROL_FOUT_SHF)

#define RTC_CONTROL_FO0_BIT		BIT0
#define RTC_CONTROL_FO1_BIT		BIT1
#define RTC_CONTROL_FO2_BIT		BIT2
#define RTC_CONTROL_FO3_BIT		BIT3

#define RTC_CONTROL_FOBATB_SHF		4
#define RTC_CONTROL_FOBATB_MSK		(MSK(1)<<RTC_CONTROL_FOBATB_SHF)
#define RTC_CONTROL_FOBATB_BIT		BIT4

#define RTC_CONTROL_LPMODE_SHF		5
#define RTC_CONTROL_LPMODE_MSK		(MSK(1)<<RTC_CONTROL_LPMODE_SHF)
#define RTC_CONTROL_LPMODE_BIT		BIT5

#define RTC_CONTROL_ALME_SHF		6
#define RTC_CONTROL_ALME_MSK		(MSK(1)<<RTC_CONTROL_ALME_SHF)
#define RTC_CONTROL_ALME_BIT		BIT6

#define RTC_CONTROL_IM_SHF		7
#define RTC_CONTROL_IM_MSK		(MSK(1)<<RTC_CONTROL_IM_SHF)
#define RTC_CONTROL_IM_BIT		BIT7


/* RTC_RESERVED		0x9 */

/* RTC_ANALOG_TRIM	0xA */

#define RTC_CONTROL_ATR_SHF		0
#define RTC_CONTROL_ATR_MSK		(MSK(6)<<RTC_CONTROL_ATR_SHF)

#define RTC_CONTROL_BMATR_SHF		6
#define RTC_CONTROL_BMATR_MSK		(MSK(2)<<RTC_CONTROL_BMATR_SHF)


/* RTC_DIGITAL_TRIM	0xB */

#define RTC_CONTROL_DTR_SHF		0
#define RTC_CONTROL_DTR_MSK		(MSK(4)<<RTC_CONTROL_DTR_SHF)

#endif /* __INCmvISL1208Regh */

